Subject: bug#5042: bug#9917: bug#5042: bug#9917: 24.0.90; Make `goto-line' consistent with the line number from the minibuffer

From: Drew Adams <[email-masked]>
Date: Wed, 23 Sep 2020 11:09:53 -0700 (PDT)

> > > 3.2. 'goto-line-relative' is bound in Info mode to `M-g M-g'.
> >
> > I gave my opinion about this.  And it was a reason given
> > for having two different commands: Do not base which
> > command gets the standard key binding on anything to do
> > with the current context - in particular, on whether the
> > buffer is narrowed.
> >
> > Please do _not_ bind `M-g M-g' to anything different in Info.
> 
> Why not?  We do this kind of thing -- have mode-specific bindings --
> all the time in Emacs.

Because we will now have two commands, with two bindings,
to let users get the behavior they want - in any mode,
any context.

Changing the binding of one of those 2 commands to invoke
the other command, makes no sense.  It takes away a
possibility (one command gets two bindings; the other
gets zero bindings).  And it confuses users.

> > Emacs should not be second-guessing users about this.
> 
> It's not second-guessing.  Info shows narrowed line numbers in its
> buffers, so from the user POV the key sequence keeps invoking the same
> command.

Info uses narrowing to show a node.  Users can further
use narrowing within a node.  Users can widen, to see
all of a file.  That Info uses narrowing for this
special purpose might be seen as a kludge.  In any
case, it's a different use of narrowing from a user's.

>From a user POV the key sequence `M-g M-g' does NOT
keep invoking the same command.  If it invoked the same
command then it would still move to an absolute position.

>From a user POV, the user has _lost_ a key binding for
one of the commands, and the other command now has two
bindings.

> I see no problem and don't see why you object so much.

So much?  I just presented my objection; that's all.

I see no reason for this.  I see reasons against it,
both wrt the particular case (Info) and in terms of
setting a bad precedent.

I don't object "so much".  I do think it would be a
mistake.  And it's not necessary.

At the very least, if you insist on this "so much",
then please consider swapping the two command bindings
in Info mode, and advertising this (anomalous swap).